/* リスト3.5 Pickingのサンプルプログラム */

import picking.*;

Picker picker; // ピッキング処理を行うクラス
float a = 0.0;

void setup() {
  size(200, 150, P3D);
  smooth();
  picker = new Picker(this);
}

void draw() {
  background(255);
  a += 0.01;
  
  lights();
  stroke(0);
  
  picker.start(0);  // 左側に表示されるオレンジ色の立方体に「0」というID番号を与える
  pushMatrix();
    translate(80, 75);
    rotateX(a); rotateY(a);
    fill(#ff8800);
    box(50);
  popMatrix();
  
  picker.start(1);  // 右側に表示される黄色の立方体に「1」というID番号を与える
  pushMatrix();
    translate(140, 75);
    rotateX(a); rotateY(a);
    fill(#eeee00);
    box(20);
  popMatrix();
  
  picker.stop();  // ピッキング処理の終端位置でstopメソッドを実行
  
  int id = picker.get(mouseX, mouseY);  // マウスポインタがある場所でピッキング判定
  switch (id) {                         // ピッキングの結果に応じて塗りつぶしの色を変更
    case -1: // no object
      fill(0); break;
    case 0:
      fill(#ff8800); break;
    case 1:
      fill(#eeee00); break;
    default:
      noFill(); break;
  }

  noStroke();
  rect(0,   0, width, 10);
  rect(0, 140, width, 10);
  rect(0,   0, 10, height);
  rect(190, 0, 10, height); 
}
