/* リスト3.6 Pickingのサンプルプログラム（画像版） */

import picking.*;

Picker picker; // ピッキング処理を行うオブジェクト
PImage icon;

void setup() {
  size(200, 200);
  picker = new Picker(this);  // ピッキングの準備
  icon = loadImage("QP.png"); // 画像のロード
}

void draw() {
  int x, y;
  background(127);
  
  picker.start(0); // これから描くものに「0」のID番号を与える
  rect(20, 10, icon.width-1, icon.height-1); // 画像と同じ位置に同サイズの四角形を描き
  image(icon, 20, 10);                       // その上から画像を描く
    
  picker.start(1); // これから描くものに「1」のID番号を与える
  rect(110, 10, icon.width-1, icon.height-1);
  image(icon, 110, 10);

  picker.stop();  // ピッキング処理の終了
  
  // ピッキング判定
  int id = picker.get(mouseX, mouseY);  // マウスカーソルがある場所を調べる
  switch (id) {                         // 結果に応じて塗りつぶし色を変更
    case -1:
      noFill(); break; // 無色
    case 0:
      fill(255,0,0); break; // 赤
    case 1:
      fill(255,255,0); break; // 黄色
  }
  
  // 判定結果を示す四角形
  rect( 20, 160, 160, 20);
}
