/* リスト3.18 ユーザの領域だけ切り出す */

import SimpleOpenNI.*;
SimpleOpenNI context;

void setup() {
  context = new SimpleOpenNI(this);
  context.enableRGB();
  context.enableDepth(); 
  context.alternativeViewPointDepthToImage();  // 視点を一致させる
  context.enableUser(SimpleOpenNI.SKEL_PROFILE_ALL);
  size(context.rgbWidth(), context.rgbHeight());
}

void draw() {
  background(255);  // 画面の初期化
  context.update();

  // ユーザマップの取得
  int[] userMap = null;
  int userCount = context.getNumberOfUsers();
  if (userCount > 0) {
    userMap = context.getUsersPixels(SimpleOpenNI.USERS_ALL);
  }
 
  loadPixels();
  for (int y=0; y<context.rgbHeight(); y++) {
    for (int x=0; x<context.rgbWidth(); x++) {
      int index = x + y * context.rgbWidth();
      if ( userMap != null && userMap[index] > 0 ) {      // ユーザがいる画素
        pixels[index] = context.rgbImage().pixels[index]; // カラー画像から抽出
      }
    } 
  }
  updatePixels();
}
