/* リスト4.6 HackAR サーバのプログラム（操作される側） */

import processing.net.*; // ネットワークライブラリ
import java.awt.*;       // GUIに関するライブラリ（Java）
import java.awt.event.*; // GUIに関するライブラリ（Java）

Server       server;  // サーバ
Robot        robot;   // マウス制御を行うクラス
DisplayMode  display; // ディスプレイ情報

void setup() {
  // サーバの準備
  server = new Server(this, 12345);
 
  // マウス制御の準備
  try {
     robot = new Robot();
  }
  catch (Exception e) {
    println("Robotの初期化に失敗しました");
  }

  // ディスプレイ情報の取得
  display = GraphicsEnvironment.getLocalGraphicsEnvironment().
            getDefaultScreenDevice().getDisplayMode();  
}

void draw() {  
  // サーバに接続しているクライアントの取得
  Client client = server.available();
  if ( client == null ) return;
  
  // クライアントからデータを受信
  String input = client.readString();      
  if ( input == null || input.indexOf("\n") < 0 ) return;
  
  // 受信したスペース区切りのデータを切り出す
  input = input.substring( 0, input.indexOf("\n") );
  String[] data = split(input, ' ');
  if ( data.length < 3 ) return;

  // 切り出したデータから正規化された座標値とボタンの押下情報を取得
  float nx = float(data[0]);
  float ny = float(data[1]);
  boolean pressed = boolean(data[2]);

  // 正規化されたカーソル座標値とディスプレイの情報から
  // スクリーン上でのカーソルの座標値を計算
  int screen_x = (int)( nx * display.getWidth() );
  int screen_y = (int)( ny * display.getHeight() );

  // マウスカーソルの移動
  robot.mouseMove( screen_x, screen_y );

  // マウスボタンの押下
  if ( pressed ) {
    robot.mousePress(InputEvent.BUTTON1_MASK);
  } else {
    robot.mouseRelease(InputEvent.BUTTON1_MASK);      
  }
}
